#!/usr/bin/perl
use File::Copy;
use strict;

my $mut=@ARGV[0];

my @componentList=( "1d", "1d.2d", "1d.2d.3d", "1d.2d.3d.4d", "1d.2d.3d.4d.s1d", "1d.2d.3d.s1d", "1d.2d.4d", "1d.2d.4d.s1d", "1d.2d.s1d", "1d.3d", "1d.3d.4d", "1d.3d.4d.s1d", "1d.3d.s1d", "1d.4d", "1d.4d.s1d", "1d.s1d", "2d", "2d.3d", "2d.3d.4d", "2d.3d.4d.s1d", "2d.3d.s1d", "2d.4d", "2d.4d.s1d", "2d.s1d", "3d", "3d.4d", "3d.4d.s1d", "3d.s1d", "4d", "4d.s1d", "s1d" );
#my @dimList=("1d","2d","3d","4d","s1d");
my @dimList=("1d","2d","3d");

use vars qw($arffDir);
$arffDir="/home/p53/classifier_v2.2/rawArff/";

#Create the correct .arff files
foreach ( @dimList )
{
  my $dim=$_;
  #print "foreach $_\n";
  my $line=getDataLine ($mut,$dim);
  #print "$line\n";
  copy($arffDir.$dim.".arff",$dim.".arff");
  open(FILE, ">>".$dim.".arff") or die "Can't open $dim.arff for write $!\n";   
  print FILE "%$mut\n";
  print FILE "$line";
  close FILE;
}

#Create the component .arff files
foreach ( @componentList )
{
  #mkdir $_;
}

#Return the data line for the given mutant name and dimension (1d,2d,3d,4d,s1d)
sub getDataLine
{
  my $mut=shift @_;
  my $dim=shift @_;

  my $fileName=$arffDir."X2.".$dim.".arff";
  open FILE, "<", $fileName or die "Can't open $fileName for reading $!\n";
  
  my $flag=0;
  while ( my $line = <FILE> )
  {

    if ($flag == 1){
      return $line;
    }
    my $tstline = substr($line,1);
    $tstline=~s/\s+$//;
    #print("$mut\n");
    if ( $mut eq $tstline )
    {
      #print "$line";
      $flag=1;
    }
  }
  close FILE;
}
