#!/bin/bash
#Copy the correct files to move into the next rolling prediction

predName=$1 #K1_X1
splitNum=$2 #Ex: 4 if you're creating the files in 4_pred
mutName=$3 #v173m_n239y
activity=$4 #active or inactive

DEF2ARFF="/home/p53/classifier_v2.2/scripts/def2arff.bash"
BASEDIR="/home/p53/classifier_v2.2/rolling/"

prevIdx=`expr $splitNum - 1`
prevFilesDir=$BASEDIR/${predName}/${prevIdx}_pred/newFiles/rawArff
prevDefDir="$BASEDIR/${predName}/${prevIdx}_pred/newFiles/def/"
mkdir rawArff
mkdir def

#Copy the train.arff files
echo "Create train.arff"
for dim in 1d 2d 3d 4d s1d
do
  echo $dim
  cp $prevFilesDir/train.$dim.arff ./rawArff/train.$dim.arff
  cat $prevFilesDir/test.${dim}.arff | grep -i -w -A 1 %$mutName >> ./rawArff/train.$dim.arff
done

#Make the train.def file
cp $prevDefDir/train.def ./def/train.def
echo "$mutName	$activity" >> ./def/train.def

#Create the test.arff files
echo "Create test.arff"
cd rawArff
echo $mutName > noTest.list
for dim in 1d 2d 3d 4d s1d
do
  echo $dim
  nice java RemoveListFromArff ${prevFilesDir}/test.$dim.arff noTest.list ./test.$dim.arff
done
cd ..

#Create the test.def file
#echo "cat $prevDefDir/test.def | grep -i -v $mutName > ./def/test.def"
cat $prevDefDir/test.def | grep -i -v $mutName > ./def/test.def
