#!/bin/bash
baseArff=$1 #EX: K1
mutArff=$2 #EX: X1
mutName=$3 #EX: v272m_n235k
workDir=$4 #EX: /home/p53/classifier_v2.2/rolling/K1_X1/0_pred/newFiles
whichXvalid=$5 #0: use standard oecv, 1: use chunk oecv (default)

if [ -z $workDir ]
then
  workDir="/home/p53/classifier_v2.2/"
fi

if [ -z $whichXvalid ]
then
  whichXvalid=1
fi

QUEUEDIR="/home/p53/queues/"
allNodes=`cat ${QUEUEDIR}*.* | tr ',\n' ','`

MAKEARFF="nice /home/p53/classifier_v2.2/scripts/makeArff.perl"
PRED="qsub -p -10 /home/p53/classifier_v2.2/scripts/predict.sge"
#COMPOSITE=" -p -10 /home/p53/classifier_v2.2/scripts/runPredComposite.allNode.sge"
COMPOSITE="nice /home/p53/classifier_v2.2/scripts/predComposite.bash"
TESTCOMP="nice /home/p53/classifier_v2.2/scripts/testCompForResub.bash"
WAIT="nice /home/p53/classifier_v2.2/scripts/waitForQueue.bash"

if [ $whichXvalid -eq 0 ]
then
  XVALID="nice /home/p53/classifier_v2.2/scripts/runclassifier.allNode"
else
  XVALID="nice /home/p53/classifier_v2.2/scripts/runclassifier.chunk"
fi

componentList="1d 1d.2d 1d.2d.3d 1d.2d.3d.4d 1d.2d.3d.4d.s1d 1d.2d.3d.s1d 1d.2d.4d 1d.2d.4d.s1d 1d.2d.s1d 1d.3d 1d.3d.4d 1d.3d.4d.s1d 1d.3d.s1d 1d.4d 1d.4d.s1d 1d.s1d 2d 2d.3d 2d.3d.4d 2d.3d.4d.s1d 2d.3d.s1d 2d.4d 2d.4d.s1d 2d.s1d 3d 3d.4d 3d.4d.s1d 3d.s1d 4d 4d.s1d s1d"

#componentList="2d"

size2d=3000

mkdir $mutName
cd $mutName

#Create the 2d file
echo $workDir
$MAKEARFF -2d --baseArff $baseArff --2dsize $size2d --outFile $baseArff.2d.filtered.arff --saveFeatures 2d.features --arffDir $workDir/rawArff --defDir $workDir/def

$MAKEARFF -2d --baseArff $mutArff --2dsize $size2d --outFile $mutArff.2d.filtered.arff --loadFeatures 2d.features --mut $mutName --arffDir $workDir/rawArff --defDir $workDir/def

rm sgeout.txt
for comp in $componentList
do
  mkdir $comp
  cd $comp

  cmpLine=`echo --$comp | sed -e 's/\./ --/g'`
  $MAKEARFF $cmpLine --2dSize $size2d --baseArff $baseArff --load2d ../$baseArff.2d.filtered.arff  --outFile train.arff --addClass --arffDir $workDir/rawArff --defDir $workDir/def
  $XVALID train.arff | awk '{ print $3 }' | sed -e 's/\..*//' >> ../sgeout.txt

  $MAKEARFF $cmpLine --2dSize $size2d --baseArff $mutArff --mut $mutName --load2d ../$mutArff.2d.filtered.arff  --outFile $mutName.arff --addClass --arffDir $workDir/rawArff --defDir $workDir/def
  $PRED $mutName.arff | awk '{ print $3 }' >> ../sgeout.txt
  cd ..
done

nodelist=`cat ./sgeout.txt | tr '\n' ','`
#Wait for these scripts to complete, then run the resub and finalize scripts
$WAIT $nodelist

$TESTCOMP .

$COMPOSITE .
#qsub -hold_jid $nodelist -q $allNodes $COMPOSITE .
