#!/bin/bash
baseArff=$1 #EX: K1
mutArff=$2 #EX: X1
workDir=$3 #EX: /home/p53/classifier_v2.2/rolling/K1_X1/0_pred/newFiles
whichXval=$4 #0: standard OECV, 1: fast OECV (default)
whichMuts=$5 #Muts to test Ex: r273l_n235k,c141y_s240r,r273c_n239y
noXval=$6 #Set to 1 to skip the xvalidation step (if it's already there)

if [ -z $workDir ]
then
  workDir="/home/p53/classifier_v2.2/"
fi

if [ -z $whichXval ]
then
  whichXval=1
fi

if [ -z $noXval ]
then
  noXval=0
fi

QUEUEDIR="/home/p53/queues/"
MAKEARFF="nice /home/p53/classifier_v2.2/scripts/makeArff.perl"
PRED="qsub -p -10 /home/p53/classifier_v2.2/scripts/predict.sge"
COMPOSITE="nice /home/p53/classifier_v2.2/scripts/predComposite.bash"
TESTCOMP="nice /home/p53/classifier_v2.2/scripts/testCompForResub.bash"
WAIT="nice /home/p53/classifier_v2.2/scripts/waitForQueue.bash"
PRESERVELIST="nice java -Xmx300mb PreserveListFromArff"

if [ $whichXval -eq 0 ]
then
  XVALID="nice /home/p53/classifier_v2.2/scripts/runclassifier.allNode"
else
  XVALID="nice /home/p53/classifier_v2.2/scripts/runclassifier.chunk"
fi

componentList="1d 1d.2d 1d.2d.3d 1d.2d.3d.4d 1d.2d.3d.4d.s1d 1d.2d.3d.s1d 1d.2d.4d 1d.2d.4d.s1d 1d.2d.s1d 1d.3d 1d.3d.4d 1d.3d.4d.s1d 1d.3d.s1d 1d.4d 1d.4d.s1d 1d.s1d 2d 2d.3d 2d.3d.4d 2d.3d.4d.s1d 2d.3d.s1d 2d.4d 2d.4d.s1d 2d.s1d 3d 3d.4d 3d.4d.s1d 3d.s1d 4d 4d.s1d s1d"
allNodes=`cat ${QUEUEDIR}*.* | tr ',\n' ','`

#componentList="2d"

size2d=3000


#Create the 2d file
echo $workDir
if [ $noXval -eq 0 ]
then
  $MAKEARFF -2d --baseArff $baseArff --2dsize $size2d --outFile $baseArff.2d.filtered.arff --saveFeatures 2d.features --arffDir $workDir/rawArff --defDir $workDir/def
fi

$MAKEARFF -2d --baseArff $mutArff --2dsize $size2d --outFile $mutArff.2d.filtered.arff --loadFeatures 2d.features --arffDir $workDir/rawArff --defDir $workDir/def

rm sgeout.txt
for comp in $componentList
do
  mkdir $comp
  cd $comp

  cmpLine=`echo --$comp | sed -e 's/\./ --/g'`
  if [ $noXval -eq 0 ]
  then
    $MAKEARFF $cmpLine --2dSize $size2d --baseArff $baseArff --load2d ../$baseArff.2d.filtered.arff  --outFile train.arff --addClass --arffDir $workDir/rawArff --defDir $workDir/def
    $XVALID train.arff | awk '{ print $3 }' | sed -e 's/\..*//' >> ../sgeout.txt
  fi

  $MAKEARFF $cmpLine --2dSize $size2d --baseArff $mutArff --load2d ../$mutArff.2d.filtered.arff  --outFile test.arff --addClass --arffDir $workDir/rawArff --defDir $workDir/def
  
  #Preserve the mutants 
  echo $whichMuts | tr ',' '\n' > testMuts.list
  java PreserveListFromArff test.arff testMuts.list test.small.arff
  mv test.small.arff test.arff

  $PRED test.arff | awk '{ print $3 }' >> ../sgeout.txt
  cd ..
done

nodelist=`cat ./sgeout.txt | tr '\n' ','`
#Wait for these scripts to complete, then run the resub and finalize scripts
$WAIT $nodelist

$TESTCOMP .
#IT does not seem to be waiting properly here...


$COMPOSITE .
#qsub -hold_jid $nodelist -q $allNodes $COMPOSITE .`
