#!/bin/bash
#Use WEKA to do an n-fold prediction of a given .arff
ARFF=$1
N=$2
OUTDIR=$3
SEED=$4

if [ -z $SEED ]
then
  RANDOM=$$
  SEED=$RANDOM
  echo "SEED = $SEED"
fi

if [ -z $OUTDIR ]
then
  OUTDIR=./results_xvalid
fi

MUTFROMIDX="nice /home/p53/classifier_v2.2/scripts/mutFromIdx.bash"
CLASSIFIER="nice java callClassifier -s $SEED"

java callClassifier weka.classifiers.SMO -t $1 -x $N | sed -e 's/ /:/g'  > ${N}_fold.out

mkdir $OUTDIR
lines=`cat ${N}_fold.out`
for line in $lines
do
  idx=`echo $line | awk -F : '{ print $1 }'`
  mut=`$MUTFROMIDX $ARFF $idx`
  echo $line | awk -F : '{ printf("PRED:\t%s\nTRUTH:\t%s\n",$2,$4) }' > ./$OUTDIR/$mut.result
done
