#!/usr/bin/python
#xvaldiation for p53 data, excluding from training set all mutants with or X mutations in common with test set.  Type python ARFFxvalid -h for details

import sys
import optparse

parser=optparse.OptionParser(usage="python ARFFxvalid.py [options] in.arff xvalid_fold output_dir > out.arff\n       python ARFFxvalid.py           in.arff > num_xvalid_folds")

parser.add_option("-m", "--max_mutations", help="Max mutations in common between test and training set. DEFAULT=0.", action="store", type="int", dest="max_mutations", metavar="N", default=0)

(options, args)=parser.parse_args()

f=file(args[0])
out=[]

data=dict()
keys=[]

header=True
for l in f:
   if header==True:
        if l.lower()[:5]=="@data":
                header=False
	out+=[l]
   else:
	if l[0]=="%":
		#key=l[:-1].lower()
		key=l.lower().strip()
	else:
		data[key]=(key[1:].split("_"), key,l.strip())
		keys+=[key]


def intersection(set1, set2):
	out =[]
	for i in set1:
		if i in set2:
			out+=[i]
	return out

def printheader(f):
	global out
	for l in out:
		print >>f, l,

#keys=data.keys()
#keys.sort()

if len(args)==1:
	print len(data.keys())
elif len(args)==3:
	xvalidfold=int(args[1])-1
	outputdir=args[2]	
	dropped=-1
	train=0
	test=1
	
	if xvalidfold<0 or xvalidfold > len(data.keys()):
		raise IOError

	#explode test set
	test_mutations,id,l = data[keys[xvalidfold]]
	f=open(outputdir+"/"+id[1:].strip()+".arff", "w")
	printheader(f)
        print >>f, id
       	print >>f, l
       	f.close()

	#Training set to stdout
	f=sys.stdout
        printheader(f)
	for k in keys:
		train_mutations,id,l=data[k]
		if len(intersection(train_mutations , test_mutations))<=options.max_mutations:
			print >>f, id
			print >>f, l
			train+=1
		else:
			dropped+=1
	f.close()
	

	print >>sys.stderr, "%i in training set.\n%i in test set\n%i dropped"%(train, test, dropped)
