#!/bin/bash
#Resubmit any mutants that failed
#run in the directory that contains the .arff file and the results_xvalid dir

ARFF=$1
WHICHXVAL=$2 #0: standard OECV, 1: fast OECV (default)

if [ -z $WHICHXVAL ]
then
  WHICHXVAL=1
fi

GETIDX="nice /home/p53/classifier_v2.2/scripts/idxFromArff.bash"
RC_SGE="/home/p53/classifier_v2.2/scripts/runclassifier.allNode.sge"
RUNCLASS="/home/p53/classifier_v2.2/scripts/runclassifier.allNode"
QUEUEDIR="/home/p53/queues/"
if [ $WHICHXVAL -eq 0 ]
then
  RUNCLASS="/home/p53/classifier_v2.2/scripts/runclassifier.allNode"
else
  RUNCLASS="/home/p53/classifier_v2.2/scripts/runclassifier.chunk"
fi

allNodes=`cat ${QUEUEDIR}*.* | tr ',\n' ','`

#First make sure that results_xvalid exists
if [ ! -d results_xvalid ]
then
  echo "Resubmit due to missing results_xvalid"
  $RUNCLASS $ARFF
  exit 0
fi

#Make sure that there are the correct number of .result files
numMut=`cat $ARFF | grep % | wc | awk '{ print $1 }'`
numRes=`/bin/ls ./results_xvalid/*.result | wc | awk '{ print $1 }'`
if [ $numMut -ne $numRes  ]
then
  echo "Resubmit due to file count mismatch"
  echo "numMut = $numMut, numRes = $numRes"
  rm -r "./results_xvalid"
  $RUNCLASS $ARFF
  exit 1
fi

#Make sure each .result file is valid
cd results_xvalid
  rm "*.result" 2> /dev/null #this is an known error file
  broken=`grep null *.result | awk -F. '{ print $1 }'`
  broken2=`find . -size 0 -print | sed -e 's/\.\///' | sed -e 's/.result//'`
cd ..

resubFlag=0
if [ ! -z $broken  ]
then
  $RUNCLASS $ARFF
  resubFlag=1
fi

if [ ! -z $broken2 ]
then
  if [ $resubFlag -eq 0 ]
  then
    $RUNCLASS $ARFF
  fi 
fi

#for mut in $broken $broken2
#do
#  echo $mut
#  idx=`$GETIDX $ARFF $mut`
#  if [ $idx -eq 1 ]
#  then
#    idx2=2
#  else
#    idx2=$idx
#  fi
  #echo "qsub -p -10 -q $allNodes -t $idx-$idx $RC_SGE $ARFF"
#  qsub -p -10 -q $allNodes -t $idx-$idx2 $RC_SGE $ARFF
#done
exit 2
