#!/bin/bash
#Used to create the reference directory for use with testImprovement.perl
prefix=$1 #Ex. K2
workDir=$2 #The directory that contains the def and arff directory

if [ -z $workDir ]
then
  workDir="/home/p53/classifier_v2.2/"
fi

DEFDIR="${workDir}/def/"
ARFFDIR="${workDir}/rawArff/"
SCRIPTDIR="/home/p53/classifier_v2.2/scripts/"

ABUT='nice java -Xmx300MB ArffAbut '


#Create the reference
mkdir ./reference

${SCRIPTDIR}/def2arff.bash ${DEFDIR}/$prefix.def > ./reference/$prefix.class.arff
for dim in 1d 2d 3d 4d s1d
do
  mkdir ./reference/$dim
  $ABUT $ARFFDIR/$prefix.$dim.arff ./reference/$prefix.class.arff > ./reference/$dim/ref.$prefix.$dim.arff
  cd ./reference/$dim  
  ${SCRIPTDIR}/runclassifier.allNode ref.$prefix.$dim.arff
  cd ../../
done

