#!/bin/bash
#Resubmit any mutants that failed in the testImprovment run.
RESUBFAILED="/home/p53/classifier_v2.2/scripts/resubFailed.bash"
WAIT="/home/p53/classifier_v2.2/scripts/waitForQueue.bash"

dims="1d 2d 3d 4d s1d"

DIR=$1 #Ex: ./1
WHICHXVAL=$2 #0: standard OECV, 1: fast OECV (default)

if [ -z $WHICHXVAL ]
then
  WHICHXVAL=1
fi


cd $DIR

jobList="init"
while [ ! -z $jobList ]
do
  echo "Testing"
  jobList=""

  cd reference
  echo reference
  for dim in $dims
  do
    cd $dim
      thisSub=`nice $RESUBFAILED ref.train.$dim.arff $WHICHXVAL`
    
      #Parse submission to get job number
      echo $thisSub
      thisSub=`echo $thisSub | sed -e 's/.*job/your job/'`
      thisJob=`echo $thisSub | grep "job" | awk '{ print $4 }' | sed -e 's/\..*//'`
      if [ ! -z $thisJob ]
      then
        validtest=`echo $thisJob | grep -v '("'`
        if [ -z $validtest ]
        then
          thisJob=`echo $thisSub | grep "job" | awk '{ print $3 }' | sed -e 's/\..*//'`
        fi

        if [ -z $jobList ]
        then
          jobList=${thisJob}
        else
          jobList=${jobList}'|'${thisJob}
        fi
      fi
    cd ..
  done
  cd ..

  dirs=`/bin/ls -d */ | grep -v reference | sed -e 's/\///'`
  echo `pwd`
  #echo $dirs
  for dir in $dirs
  do
    cd $dir
    for act in active inactive
    do
      cd $act
      for dim in $dims
      do 
        cd $dim
        echo "$dir/$act/$dim/"
        thisSub=`nice $RESUBFAILED in.arff $WHICHXVAL`

        #Parse submission to get job number
        echo $thisSub
        thisSub=`echo $thisSub | sed -e 's/.*job/your job/'`
        #thisJob=`echo $thisSub | grep "job-array" | awk '{ print $4 }' | sed -e 's/\..*//'`
        thisJob=`echo $thisSub | grep "job" | awk '{ print $4 }' | sed -e 's/\..*//'`
        if [ ! -z $thisJob ]
        then
          validtest=`echo $thisJob | grep -v '("'`
          #if [ $thisJob == "(\"runclassifier" ]
          if [ -z $validtest ]
          then
            thisJob=`echo $thisSub | grep "job" | awk '{ print $3 }' | sed -e 's/\..*//'`
          fi

          if [ -z $jobList ]
          then
            jobList=${thisJob}
          else
            jobList=${jobList}'|'${thisJob}
          fi
        fi

        cd ..
      done
    cd ..
    done
    cd ..
  done

  #Wait until the jobs are done 
  $WAIT $jobList
done
