#!/bin/bash
#call testImprovement.perl and testDef to determine the best new mutant predict
basePrefix=$1 #EX: K1
newPrefix=$2 #EX: X1
outDir=$3 #Ex: 2 //to run the second round of predictions
workDir=$4 #Ex: /home/p53/classifier_v2.2/rolling/K1_X1/0_pred/newFiles
nFold=$5 #Ex: 10 for 10-fold

if [ -z $workDir ]
then
  workDir="/home/p53/classifier_v2.2/"
fi


DEFDIR="${workDir}/def/"
SCRIPTDIR="/home/p53/classifier_v2.2/scripts/"
DEFFILE="${DEFDIR}/${newPrefix}.def"
TALLY="nice /home/p53/classifier_v2.2/scripts/tallyResults.bash"
QUEUEDIR="/home/p53/queues/"
allNodes=`cat ${QUEUEDIR}*.* | tr ',\n' ','`

muts=`cat $DEFFILE | awk '{ print $1 }'`
mkdir $outDir 2> /dev/null
rm ./$outDir/subFile.txt 2> /dev/null
for mut in $muts
do
  echo $mut
  #echo "qsub -p -10 -q $allNodes ${SCRIPTDIR}testImprovement.nFold.perl.sge $mut $basePrefix $newPrefix $outDir $nFold $workDir | tee ./$outDir/thisSub.txt"
  qsub -p -10 -q $allNodes ${SCRIPTDIR}testImprovement.nFold.perl.sge $mut $basePrefix $newPrefix $outDir $nFold $workDir | tee ./$outDir/thisSub.txt
  #cat ./$outDir/thisSub.txt | grep job-array >> ./$outDir/subFile.txt
done

cd $outDir
  qsub -p -10 -q $allNodes ${SCRIPTDIR}testDef.nFold.bash.sge $basePrefix $workDir $nFold | tee thisSub.txt
  cat ./thisSub.txt | grep job-array >> ./subFile.txt
  rm thisSub.txt
cd ..

#Wait for these jobs to finish and then wait for resubmission
#subjobs=`cat subFile.txt | awk '{ print $3 }' | sed -e 's/\..*//' | tr '\n' ','`
#${SCRIPTDIR}waitForQueue.bash $subJobs
#${SCRIPTDIR}testForResub.bash $outDir

#Tally Results
#mkdir ${outDir}_pred
#$TALLY ${outDir} | sort > ./${outDir}_pred/tally.txt
