#!/usr/bin/perl
use File::Copy;
use strict;

my $mut=@ARGV[0];  #EX: r273h_s240k
my $baseArff=@ARGV[1]; #EX: K2.S
my $newArff=@ARGV[2];  #EX: X2
my $baseDir=@ARGV[3]; #EX: ./test
my $nFold=@ARGV[4]; #EX: 10
my $workDir;
if ( @ARGV[5] ) {
  $workDir=@ARGV[5]; 
} else {
  $workDir="/home/p53/classifier_v2.2/";
}

#my @componentList=( "1d", "1d.2d", "1d.2d.3d", "1d.2d.3d.4d", "1d.2d.3d.4d.s1d", "1d.2d.3d.s1d", "1d.2d.4d", "1d.2d.4d.s1d", "1d.2d.s1d", "1d.3d", "1d.3d.4d", "1d.3d.4d.s1d", "1d.3d.s1d", "1d.4d", "1d.4d.s1d", "1d.s1d", "2d", "2d.3d", "2d.3d.4d", "2d.3d.4d.s1d", "2d.3d.s1d", "2d.4d", "2d.4d.s1d", "2d.s1d", "3d", "3d.4d", "3d.4d.s1d", "3d.s1d", "4d", "4d.s1d", "s1d" );
my @dimList=("1d","2d","3d","4d","s1d");
my @componentList=( "1d", "2d", "3d", "4d", "s1d" );
#my @dimList=("1d","3d","4d","s1d");
#my @dimList=("1d","2d","3d");
my $scriptDir="/home/p53/classifier_v2.2/scripts/";

my $arffDir="$workDir/rawArff/";
my $defDir="$workDir/def/";

my $defFile=$defDir.$baseArff.".def";

mkdir $baseDir;
chdir $baseDir;
rmdir $mut;
mkdir $mut;
chdir $mut;

#Create the correct .arff files
foreach ( @dimList )
{
  my $dim=$_;
  print "foreach $_\n";
  my $newFile=$arffDir.$newArff;
  my $line=getDataLine ($mut,$dim,$newFile);
  #print "$line\n";
  copy($arffDir.$baseArff.".".$dim.".arff",$mut.".".$baseArff.".".$dim.".arff");
  open(FILE, ">>".$mut.".".$baseArff.".".$dim.".arff") or die "Can't open $dim.arff for write $!\n";   
  print FILE "%$mut\n";
  print FILE "$line";
  close FILE;
}

#Make the positive and negative .arff files
copy($defFile,"active.def");
open(FILE, ">>active.def") or die "Can't open active.def\n";
print FILE "$mut\tactive\n";
close FILE;
system($scriptDir."def2arff.bash active.def > active.arff");

copy($defFile,"inactive.def");
open(FILE, ">>inactive.def") or die "Can't open inactive.def\n";
print FILE "$mut\tinactive\n";
close FILE;
system($scriptDir."def2arff.bash inactive.def > inactive.arff");

#Create the component .arff files
my @activity=("active","inactive");
foreach (@activity){
  my $act=$_;
  mkdir $act;
  chdir $act;

  foreach ( @componentList )
  {
    my $comp=$_;
    mkdir $comp;
    chdir $comp;
    unlink ("in.arff"); #why is delete called unlink?
    my @comps=split(/\./, $comp);
    foreach ( @comps )
    {  
      my $dim=$_;
      print("$comp\: ".$dim."\n");
      my $dimFile="../../".$mut.".".$baseArff.".".$dim.".arff";
      print($dimFile."\n");
      if (-e "in.arff") {
        system("nice java -Xmx300MB ArffAbut in.arff $dimFile > temp.arff");
        copy("temp.arff","in.arff");
      } else {
        copy($dimFile, "in.arff");
      }
    }
    system("nice java -Xmx300MB ArffAbut in.arff ../../".$act.".arff > temp.arff");
    copy("temp.arff","in.arff");
    if ($comp=="2d") {
      
      system($scriptDir."runMI.bash in.arff 3000 > 2d.features");
      system("nice java -Xmx300MB FilterFeatures 2d.features in.arff 1 > /dev/null");
      rename("in.arff","in.allFeatures.arff");
      rename("best.in.arff","in.arff");
    }
    system($scriptDir."predictNfold.bash in.arff $nFold ./results_xvalid");
    chdir "..";
  }
  chdir "..";
}

#Return the data line for the given mutant name and dimension (1d,2d,3d,4d,s1d)
sub getDataLine
{
  my $mut=shift @_;
  my $dim=shift @_;
  my $newArff=shift @_;

  #my $fileName="/home/p53/classifier_v2.2/rawArff/X2.".$dim.".arff";
  my $fileName=$newArff.".".$dim.".arff";
  open FILE, "<", $fileName or die "Can't open $fileName for reading $!\n";
  
  my $flag=0;
  while ( my $line = <FILE> )
  {
    if ($flag == 1){
      return $line;
    }
    my $tstline = substr($line,1);
    $tstline=~s/\s+$//;
    #print("$mut\n");
    if ( $mut eq $tstline )
    {
      #print "$line";
      $flag=1;
    }
  }
  close FILE;
}
