#!/bin/bash
#call testImprovement.perl and testDef to determine the best new mutant predict
basePrefix=$1 #EX: K1
newPrefix=$2 #EX: X1
outDir=$3 #Ex: 2 //to run the second round of predictions
workDir=$4 #Ex: /home/p53/classifier_v2.2/rolling/K1_X1/0_pred/newFiles

if [ -z $workDir ]
then
  workDir="/home/p53/classifier_v2.2/"
fi


DEFDIR="${workDir}/def/"
SCRIPTDIR="/home/p53/classifier_v2.2/scripts/"
DEFFILE="${DEFDIR}/${newPrefix}.def"
TALLY="nice /home/p53/classifier_v2.2/scripts/tallyResults.bash"
QUEUEDIR="/home/p53/queues/"
allNodes=`cat ${QUEUEDIR}*.* | tr ',\n' ','`

muts=`cat $DEFFILE | awk '{ print $1 }'`
mkdir $outDir 2> /dev/null
rm ./$outDir/subFile.txt 2> /dev/null
cd $outDir
for activity in "active" "inactive"
do
  echo "!!$activity!!"
  for mut in $muts
  do
  echo $mut
    #echo "qsub -p -10 -q $allNodes ${SCRIPTDIR}testImprovement.nFold.perl.sge $mut $basePrefix $newPrefix $outDir $nFold $workDir | tee ./$outDir/thisSub.txt"
    qsub -p -10 -q $allNodes ${SCRIPTDIR}testImprovement.oecv.perl.sge $mut $basePrefix $newPrefix . $workDir $activity | tee ./thisSub.txt
    cat ./thisSub.txt | grep job >> ./subFile.txt
  done
done

echo REFERENCE
#cd $outDir
nice ${SCRIPTDIR}testDef.oecv.bash $basePrefix $workDir | tee thisSub.txt

#Wait for these jobs to finish and then wait for resubmission
cat ./thisSub.txt | grep job >> ./subFile.txt
rm thisSub.txt
#subjobs=`cat subFile.txt | awk '{ print $3 }' | sed -e 's/\..*//' | tr '\n' ','`
subJobs=`cat subFile.txt | awk '{ print $3 }' | tr '\n' ','`
#echo "${SCRIPTDIR}waitForQueue.bash $subJobs"
${SCRIPTDIR}waitForQueue.bash $subJobs 

#FIRST TEST FOR CHUNK RESUB< THEN WAIT< THE TEST FOR OTHER RESUB
#${SCRIPTDIR}testForResub.bash $outDir


#Tally Results
cd ..
mkdir ${outDir}_pred
$TALLY ${outDir} | sort -g > ./${outDir}_pred/tally.txt

