#!/bin/bash

#Wait for jobs in job array.  Separate list with "," or "|"
jobList=`echo $1 | sed -e 's/,/|/g' | sed -s 's/|$//'`

#Wait until the jobs are done (count to 120 mins to prevent hanging)
if [ ! -z $jobList ]
then
  idx=0
  echo "runJobs=qstat | egrep \"$jobList\" | grep -v Eqw"
  runJobs=`qstat | egrep "$jobList" | grep -v Eqw`
  rj=`echo $runJobs | awk '{ print $1 }'`
  echo "rj = $rj"
  while [ ! -z $rj ]
  do
    echo "Sleeping: waiting for $rj"
    sleep 30s
    runJobs=`qstat | egrep "$jobList" | grep -v Eqw`
    #echo "runJobs = $jobList"
    rj=`echo $runJobs | awk '{ print $1 }'`
    idx=`expr $idx + 1`
    if [ $idx -eq 240 ]
    then
      exit 1
    fi
  done
fi
