#!/bin/bash
baseArff=$1 #EX: K1
mutArff=$2 #EX: X1
workDir=$3 #EX: /home/p53/classifier_v2.2/rolling/K1_X1/0_pred/newFiles
whichXval=$4 #0: standard OECV, 1: fast OECV (default)
size2d=$5 #Default is 3000, 200 is best when using DNA region
remove4d=$6 #Set to 1 to not consider 4d in xvalidation

if [ -z $workDir ]
then
  workDir="/home/p53/classifier_v3.0/"
fi

if [ -z $whichXval ]
then
  whichXval=1
fi

if [ -z $size2d ]
then
  size2d=3000
else
  echo "$5 Features to be selected from 2d"
fi

componentList="1d 1d.2d 1d.2d.3d 1d.2d.3d.4d 1d.2d.3d.4d.s1d 1d.2d.3d.s1d 1d.2d.4d 1d.2d.4d.s1d 1d.2d.s1d 1d.3d 1d.3d.4d 1d.3d.4d.s1d 1d.3d.s1d 1d.4d 1d.4d.s1d 1d.s1d 2d 2d.3d 2d.3d.4d 2d.3d.4d.s1d 2d.3d.s1d 2d.4d 2d.4d.s1d 2d.s1d 3d 3d.4d 3d.4d.s1d 3d.s1d 4d 4d.s1d s1d"
if [ -z $remove4d ]
then
  componentList=$componentList
else
  if [ $remove4d -eq 1 ]
  then
    componentList="1d 1d.2d 1d.2d.3d 1d.2d.3d.s1d 1d.2d.s1d 1d.3d 1d.3d.s1d 1d.s1d 2d 2d.3d 2d.3d.s1d 2d.s1d 3d 3d.s1d s1d"
  fi
fi

QUEUEDIR="/home/p53/queues/"
MAKEARFF="nice /home/p53/classifier_v3.0/scripts/makeArff.perl"
allNodes=`cat ${QUEUEDIR}*.* | tr ',\n' ','`
PRED="qsub -q $allNodes -p -10 /home/p53/classifier_v3.0/scripts/predict.sge"
COMPOSITE="nice /home/p53/classifier_v3.0/scripts/predComposite.bash"
TESTCOMP="nice /home/p53/classifier_v3.0/scripts/testCompForResub.bash"
WAIT="nice /home/p53/classifier_v3.0/scripts/waitForQueue.bash"

if [ $whichXval -eq 0 ]
then
  XVALID="nice /home/p53/classifier_v3.0/scripts/runclassifier.allNode"
else
  XVALID="nice /home/p53/classifier_v3.0/scripts/runclassifier.chunk"
fi

#componentList="2d"



#Create the 2d file
echo $workDir
$MAKEARFF -2d --baseArff $baseArff --2dsize $size2d --outFile $baseArff.2d.filtered.arff --saveFeatures 2d.features --arffDir $workDir/rawArff --defDir $workDir/def

$MAKEARFF -2d --baseArff $mutArff --2dsize $size2d --outFile $mutArff.2d.filtered.arff --loadFeatures 2d.features --arffDir $workDir/rawArff --defDir $workDir/def

rm sgeout.txt
for comp in $componentList
do
  mkdir $comp
  cd $comp

  cmpLine=`echo --$comp | sed -e 's/\./ --/g'`
  $MAKEARFF $cmpLine --2dSize $size2d --baseArff $baseArff --load2d ../$baseArff.2d.filtered.arff  --outFile train.arff --addClass --arffDir $workDir/rawArff --defDir $workDir/def
  $XVALID train.arff | awk '{ print $3 }' | sed -e 's/\..*//' >> ../sgeout.txt

  $MAKEARFF $cmpLine --2dSize $size2d --baseArff $mutArff --load2d ../$mutArff.2d.filtered.arff  --outFile test.arff --addClass --arffDir $workDir/rawArff --defDir $workDir/def
  $PRED test.arff | awk '{ print $3 }' >> ../sgeout.txt
  cd ..
done

nodelist=`cat ./sgeout.txt | tr '\n' ','`
#Wait for these scripts to complete, then run the resub and finalize scripts
$WAIT $nodelist

$TESTCOMP .
#IT does not seem to be waiting properly here...


$COMPOSITE .
#qsub -hold_jid $nodelist -q $allNodes $COMPOSITE .`

#Version 3.0  Sam Danziger 13:11:55
#  Modified to include or not include 4d
