#!/bin/bash
#Resubmit any mutants that failed
#run in the directory that contains the .arff file and the results dir

ARFF=$1 #EX: y273c.arff

GETIDX="nice /home/p53/classifier_v3.0/scripts/idxFromArff.bash"
RC_SGE="/home/p53/classifier_v3.0/scripts/runclassifier.allNode.sge"
#RUNCLASS="/home/p53/classifier_v2.2/scripts/runclassifier.allNode"
QUEUEDIR="/home/p53/queues/"

allNodes=`cat ${QUEUEDIR}*.* | tr ',\n' ','`
PRED="qsub -p -10 -q $allNodes /home/p53/classifier_v3.0/scripts/predict.sge"


#First make sure that results_xvalid exists
if [ ! -d results ]
then
  $PRED $ARFF
  exit 0
fi

#Make sure that there are the correct number of .result files
numMut=`cat $ARFF | grep % | wc | awk '{ print $1 }'`
numRes=`/bin/ls ./results/*.result | wc | awk '{ print $1 }'`
if [ $numMut -ne $numRes  ]
then
  rm -r "./results"
  $PRED $ARFF
  exit 1
fi

#Make sure each .result file is valid
cd results
  rm "*.result" >/dev/null 2> /dev/null #this is an known error file
  broken=`grep null *.result | awk -F. '{ print $1 }'`
  broken2=`find . -size 0 -print | sed -e 's/\.\///' | sed -e 's/.result//'`
cd ..


#if [ ! -z "$broken" || ! -z "$broken2" ]
resubFlag=0
if [ ! -z "$broken" ]
then
  $PRED $ARFF
  resubFlag=1
fi

if [ ! -z "$broken2" ]
then
  if [ $resubFlag -eq 0 ]
  then
    $PRED $ARFF
  fi
fi

exit 2
