#!/bin/bash
arff=$1
numFeatures=$2

#Step 1: Create the X features from the arff file
#dir=`echo $arff | sed -e 's/.arff//' | sed -e 's/^.*\///'`.dir
#mkdir $dir
#mkdir $dir/$numFeatures
#cp $arff ./$dir/$numFeatures/raw.arff

#cd $dir/$numFeatures

#Mutual Information
MUT_INFO="nice java -Xmx300MB weka.filters.AttributeSelectionFilter -S weka.attributeSelection.Ranker -E weka.attributeSelection.InfoGainAttributeEval"

if [ -a $arff ] 
then
  $MUT_INFO -i $arff -o ./features.arff -c last
else
  echo "File Not Found: $arff" > /dev/stderr
  exit
fi

features=`cat ./features.arff | grep @attribute | awk '{ print $2 }'`

ctr=1
for feature in $features
do
  echo $feature
  if [ $ctr == $numFeatures ]
  then
    break
  fi
  ctr=$(($ctr+1))
done > temp
echo class >> temp

echo $arff: $numFeatures features
cat temp | tr '\n' ','
rm temp


#Version 3.0 Sam Danziger 3/09/05 11:01:05
#  Modificed for classifier_v3.0.  Add checking to see fi file really exists
