#!/bin/bash
#Should only be called in a  script called within a sun grid engine script.  Otherwise se runkclassifier.chunk

ARFF=$1

CLASSIFIER=${2-SMO}
if [ -e CLASSIFIER ]
then
        CLASSIFIER=`cat CLASSIFIER`
fi

WEKA="nice java -Xmx300mb weka.classifiers.$CLASSIFIER "

OUT_DIR=${1%/*}
XVALID="nice python /home/p53/classifier_v2.2/scripts/python/ARFFxvalid.py --max_mutations=1"
TRAIN=$TMPDIR/train/train.arff
OUTPREFIX=${ARFF%.arff}
MODEL=$TMPDIR/model.gz

numSplits=`$XVALID --max_mutations=1 $ARFF`

idx=1
while [ $idx -le $numSplits ]
do

  echo 
  echo FOR XVAL $idx

  echo GENERAGE XVAL FILES
  mkdir $TMPDIR/train
  echo "$XVALID $ARFF $idx $TMPDIR/ > $TRAIN"
  $XVALID $ARFF $idx $TMPDIR/ > $TRAIN

  for f in $TMPDIR/*.arff
  do
    id=${f%.arff}
    id=${id##*/}
 
    echo BUILD MODEL with: $WEKA
    $WEKA -t $TRAIN -T $TRAIN -d $MODEL > $TMPDIR/out
    break
  done

  echo TEST MODEL
  if [ ! -e results_xvalid ]
  then 
    mkdir results_xvalid
  fi

  for f in $TMPDIR/*.arff
  do
    id=${f%.arff}
    id=${id##*/}
    $WEKA -l $MODEL -T $f > $TMPDIR/${id}.out
    nice java Wekaout2Result $TMPDIR/${id}.out > results_xvalid/$id.result
  done

  rm -r $TMPDIR/train
  rm $TMPDIR/*.arff
  idx=`expr $idx + 1`
done
echo DONE

#Version 3.0  Sam Danziger 3/9/05 13:25:26
#  Modifier to work with classifier_v3.0
