#!/bin/bash
#Resubmit any mutants that failed in the testImprovment run.
RESUBFAILED="nice /home/p53/classifier_v3.0/scripts/resubFailed.bash"
RESUBPRED="nice /home/p53/classifier_v3.0/scripts/resubFailedPred.bash"
WAIT="nice /home/p53/classifier_v3.0/scripts/waitForQueue.bash"

dims="1d 2d 3d 4d s1d"

DIR=$1 #Ex: ./1
WHICHXVALID=$2

if [ -z $WHICHXVALID ]
then
  WHICHXVALID=0
fi


cd $DIR

#Test the crossvalidated
dirs=`/bin/ls -d *d`
jobList="init"
while [ ! -z $jobList ]
do
  echo "Test Components"
  jobList=""
  for dir in $dirs
  do
    cd $dir
    echo "$dir"
    #Pass 1 tests predict, pass 2 tests xvalid
    for pass in 1 2
    do
      if [ $pass -eq 1 ]
      then
        arffFile=`/bin/ls *.arff | grep -v train.arff`
        #echo "Test Predict: $arffFile"
        #echo "thisSub=`nice $RESUBPRED $arffFile`"
        thisSub=`nice $RESUBPRED $arffFile`
      else
        #echo "Test Xvalid"
        #echo "thisSub=`nice $RESUBFAILED train.arff $WHICHXVALID`"
        thisSub=`nice $RESUBFAILED train.arff $WHICHXVALID`
      fi

      echo $thisSub
      thisSub=`echo $thisSub | sed -e 's/.*job/your job/'`
      thisJob=`echo $thisSub | grep "job-array" | awk '{ print $4 }' | sed -e 's/\..*//'`
      if [ ! -z $thisJob ]
      then
        if [ $thisJob == "(\"runclassifier" ]
        then
          thisJob=`echo $thisSub | grep "job-array" | awk '{ print $3 }' | sed -e 's/\..*//'`
        fi

        if [ -z $jobList ]
        then 
          jobList=${thisJob}
        else
          jobList=${jobList}'|'${thisJob}
        fi
      fi
    done
    cd ..
  done

  #Wait until the jobs are done
  $WAIT $jobList
done
