#!/usr/bin/perl
use File::Copy;
use strict;

my $mut=@ARGV[0];  #EX: r273h_s240k
my $baseArff=@ARGV[1]; #EX: K2.S
my $newArff=@ARGV[2];  #EX: X2
my $baseDir=@ARGV[3]; #EX: ./test
my $workDir;
if ( @ARGV[4] ) {
  $workDir=@ARGV[4]; 
} else {
  $workDir="/home/p53/classifier_v3.0/";
}
my $activity=@ARGV[5]; #Chose active or inactive for this run
my $num2dFeatures;
if ( @ARGV[6] ) {
  $num2dFeatures=@ARGV[6];
} else {
  $num2dFeatures=3000;
}

#my @componentList=( "1d", "1d.2d", "1d.2d.3d", "1d.2d.3d.4d", "1d.2d.3d.4d.s1d", "1d.2d.3d.s1d", "1d.2d.4d", "1d.2d.4d.s1d", "1d.2d.s1d", "1d.3d", "1d.3d.4d", "1d.3d.4d.s1d", "1d.3d.s1d", "1d.4d", "1d.4d.s1d", "1d.s1d", "2d", "2d.3d", "2d.3d.4d", "2d.3d.4d.s1d", "2d.3d.s1d", "2d.4d", "2d.4d.s1d", "2d.s1d", "3d", "3d.4d", "3d.4d.s1d", "3d.s1d", "4d", "4d.s1d", "s1d" );
my @dimList=("1d","2d","3d","4d","s1d");
my @componentList=( "1d", "2d", "3d", "4d", "s1d" );
#my @dimList=("1d","3d","4d","s1d");
#my @dimList=("1d","2d","3d");
my $scriptDir="/home/p53/classifier_v3.0/scripts/";
my $runClassifier=$scriptDir."runclassifier.bash ";

my $arffDir="$workDir/rawArff/";
my $defDir="$workDir/def/";

my $defFile=$defDir.$baseArff.".def";

mkdir $baseDir;
chdir $baseDir;
rmdir $mut;
mkdir $mut;
chdir $mut;

#Create the correct .arff files
foreach ( @dimList )
{
  my $dim=$_;
  my $createdFile=$activity.".".$mut.".".$baseArff.".".$dim.".arff";
    
  print "foreach $_\n";
  my $newFile=$arffDir.$newArff;
  my $line=getDataLine ($mut,$dim,$newFile);
    
  my $baseArffFile = $arffDir.$baseArff.".".$dim.".arff";
  if ( -e $baseArffFile ) 
  {
    copy($baseArffFile,$createdFile);
    open(FILE, ">>".$createdFile) or die "Can't open $dim.arff for write $!\n";
    print FILE "%$mut\n";
    print FILE "$line";
    close FILE;
  } else {
    print STDERR "File not found: $baseArffFile";
    exit
  }
}

#Make the positive and negative .arff files
if ( $activity eq 'active' ) {
  copy($defFile,"active.def");
  open(FILE, ">>active.def") or die "Can't open active.def\n";
  print FILE "$mut\tactive\n";
  close FILE;
  system($scriptDir."def2arff.bash active.def > active.arff");
} else {
  copy($defFile,"inactive.def");
  open(FILE, ">>inactive.def") or die "Can't open inactive.def\n";
  print FILE "$mut\tinactive\n";
  close FILE;
  system($scriptDir."def2arff.bash inactive.def > inactive.arff");
}

#my @activity=("active","inactive");
#foreach (@activity){
  my $act=$activity;
  mkdir $act;
  chdir $act;

  foreach ( @componentList )
  {
    my $comp=$_;
    mkdir $comp;
    chdir $comp;
    unlink ("in.arff"); #why is delete called unlink?
    my @comps=split(/\./, $comp);
    foreach ( @comps )
    {  
      my $dim=$_;
      print("$comp\: ".$dim."\n");
      my $dimFile="../../$activity.".$mut.".".$baseArff.".".$dim.".arff";
      print($dimFile."\n");
      if (-e "in.arff") {
        system("nice java -Xmx300MB ArffAbut in.arff $dimFile > temp.arff");
        copy("temp.arff","in.arff");
      } else {
        copy($dimFile, "in.arff");
      }
    }
    system("nice java -Xmx300MB ArffAbut in.arff ../../".$act.".arff > temp.arff");
    copy("temp.arff","in.arff");
    if ($comp=="2d") {
      
      system($scriptDir."runMI.bash in.arff $num2dFeatures > 2d.features");
      system("nice java -Xmx300MB FilterFeatures 2d.features in.arff 1 > /dev/null");
      system("bzip2 -f 2d.features");
      rename("in.arff","in.allFeatures.arff");
      rename("best.in.arff","in.arff");
    }
    rename("in.arff","in.bak");
    system("rm *.arff");
    rename("in.bak","in.arff");
    print "\tRUNNING CLASSIFIER: nice ".$runClassifier." in.arff\n";
    system("nice ".$runClassifier." in.arff");
    system("bzip2 -f in.arff");
    chdir "..";
  }
  chdir "..";
  system("bzip2 -f *.arff");

#}

#Return the data line for the given mutant name and dimension (1d,2d,3d,4d,s1d)
sub getDataLine
{
  my $mut=shift @_;
  my $dim=shift @_;
  my $newArff=shift @_;

  #my $fileName="/home/p53/classifier_v2.2/rawArff/X2.".$dim.".arff";
  my $fileName=$newArff.".".$dim.".arff";
  open FILE, "<", $fileName or die "Can't open $fileName for reading $!\n";
  
  my $flag=0;
  while ( my $line = <FILE> )
  {
    if ($flag == 1){
      return $line;
    }
    my $tstline = substr($line,1);
    $tstline=~s/\s+$//;
    #print("$mut\n");
    if ( $mut eq $tstline )
    {
      #print "$line";
      $flag=1;
    }
  }
  close FILE;
}

#Version 3.0  Sam Danziger 3/09/05
#  Modified for classifier_v3.0.  Added error checking and reporting. 
#  Also will compress intermediate files
