import java.io.*;
import java.util.*;

/**
 * 
 * @author Sam Danziger
 *
 * Adds a name to a .arff given the ordered list of names in a .def file
 */
class AddNameFromDef {
	public AddNameFromDef(String arffName, String defName){
		try {
			FileReader inFile = new FileReader(arffName);
			BufferedReader arffIn = new BufferedReader(inFile);			

			FileReader inFile2 = new FileReader(defName);
			BufferedReader defIn = new BufferedReader(inFile2);			

			//Header
			String line = arffIn.readLine();
			while (!(line.toLowerCase()).startsWith("@data")){
				System.out.println(line);
				line = arffIn.readLine();
			}

			//@data
			System.out.println(line);
			line = arffIn.readLine();
			
			String defLine = defIn.readLine();
			while (line != null && defLine !=null){
				//Get Name
				StringTokenizer tok = new StringTokenizer(defLine);
				System.out.println("%"+tok.nextToken());
				
				//Data line
				System.out.println(line);

				line = arffIn.readLine();
				defLine = defIn.readLine();
			}

			arffIn.close();
			defIn.close();
		} catch (Exception e){
			System.out.println(e.getMessage());
			e.printStackTrace();
		}
	}

	/**
	 * Add the %name in the line before each data line based on a .def file
	 *		AddNameFromDef <arffName> <defName>
	 *		AddNameToArff spectrum_3.arff K2.def > 1dh.arff"
	 *
	 * @param args
	 */
	public static void main (String args []) {
		if (args.length != 2){
			System.out.println("Add the %name in the line before each data line based on a .def file");
			System.out.println("AddNameFromDef <arffName> <defName>" );
			System.out.println("AddNameToArff spectrum_3.arff K2.def > 1dh.arff" );
		} else {
			String arffName = args[0];
			String defName = args[1];
			AddNameFromDef myAddNameFromDef = new AddNameFromDef(arffName, defName);
			//System.out.println("Completed Execution: AddNameToArff "+arffName);
		}
	}
}