import java.io.*;

/**
 *
 * @author Sam Danziger
 *
 * Remove the extra info from the 3d arff file and save
 * it as a separate file
 */
class Arff2Def {
	public Arff2Def(String arffName){
		try {
			FileReader inFile = new FileReader(arffName);
			BufferedReader in = new BufferedReader(inFile);

			//Title
			String line = in.readLine();
			while (!(line.toLowerCase()).startsWith("@data")){
				line = in.readLine();
			}

			//@data
			line = in.readLine();
			while (line != null){
				//Name Line
				line=line.substring(1);
				System.out.print(line+"\t");
				line = in.readLine();

				//Data line
				if((line.toLowerCase()).indexOf("inactive")==-1){
					System.out.print("active\n");
				} else {
					System.out.print("inactive\n");
				}
				line = in.readLine();
			}

			in.close();
		} catch (Exception e){
			System.out.println(e.getMessage());
			e.printStackTrace();
		}
	}


	/**
	 * Use the class information in a .arff file to make a .def file
	 * Arff2Def <arffName> > <defName>
	 *
	 * @param args
	 */
	public static void main (String args []) {
		if (args.length != 1){
			System.out.println("Use the class information in a .arff file to make a .def file");
			System.out.println("Arff2Def <arffName> > <defName>" );
		} else {
			String arffName = args[0];
			Arff2Def myArff2Def = new Arff2Def(arffName);
			//System.out.println("Completed Execution: RemoveActive "+arffName);
		}
	}

}
