import java.io.*;
/**
 *
 * @author sad1225
 *
 * Combine the many weka files created for the 2d under the
 * same header and name each instance.
 * ASSUME
 */
class Combine2Arff{
	/**
	 * Constructor
	 * @param inFile1	  The first .arff Files
	 * @param inFile2	  The second .arff Files
	 * @param outFileName The output file to write too
	 */
	public Combine2Arff(String inFile1, String inFile2, String outFileName){
		try{
			FileReader arffInFile = new FileReader(inFile1);
			BufferedReader inArff1 = new BufferedReader(arffInFile);

			FileReader inFile = new FileReader(inFile2);
			BufferedReader inArff2 = new BufferedReader(inFile);

			FileWriter outFile = new FileWriter(outFileName);
			PrintWriter outArff = new PrintWriter(outFile);


			//Step 1:  Copy the header
			String arffLine = inArff1.readLine();
			while(!((arffLine.toLowerCase()).startsWith("@data"))){
				outArff.println(arffLine);
				arffLine = inArff1.readLine();
			}

			outArff.println(arffLine);

			String line = null;

			//Step 2, write the rest of the first file
			arffLine = inArff1.readLine();
			while(arffLine!=null){
			    //line = listReader.readLine();
			    //outArff.println("%"+line);
				outArff.println(arffLine);
				arffLine = inArff1.readLine();
			}

			//Step 3, read/write the rest of the second file
			arffLine = inArff2.readLine();
		    while(!((arffLine.toLowerCase()).startsWith("@data"))){
				arffLine = inArff2.readLine();
			}
			arffLine = inArff2.readLine();

			while(arffLine!=null){
				outArff.println(arffLine);
				arffLine = inArff2.readLine();
			}

			inArff1.close();
			inArff2.close();
			outArff.close();
		} catch (Exception e){
			e.printStackTrace();
		}

	}

	/**
	 * Provide command line interface
	 * @param args
	 */
	public static void main (String args []){
		if (args.length != 3){
			System.out.println("Combine two .arff files with identical headers");
			System.out.println("\tCombine2Arff <file1> <file2> <outFile>");
			System.out.println("ex: Combine2Arff n239y.arff s240r.arff combo.arff");
		} else {
			Combine2Arff myCombineArff = new Combine2Arff(args[0], args[1], args[2]);
		}
	}

}