import java.io.*;
import java.util.*;

/**
 * 
 * @author Sam Danziger
 *
 * Remove any lines from a .arff file where the number of points in the data != the number of attributes.
 */

class FixBrokenArff{

	public FixBrokenArff(String arffName){
		int attribCount=0; //Count the number of attributes in the .arff file
		
		try {
			//Create the list of all the names and activity from the .def file
			FileReader inFile = new FileReader(arffName);
			BufferedReader in = new BufferedReader(inFile);			

			//Process the header
			String line = in.readLine();
			while (!(line.toLowerCase()).startsWith("@attribute")){
				System.out.println(line);
				line = in.readLine();
			}

			//Count the number of attributes
			attribCount=0;
			while ((line.toLowerCase()).startsWith("@attribute")){
				attribCount++;
				System.out.println(line);
				line = in.readLine();
			}
			
			//Process the data
			System.out.println(line); //@data
			line = in.readLine();

			while (line != null){
				if (line.length() != 0) {
					String line2=in.readLine();
					StringTokenizer tok = new StringTokenizer(line2,",");
					int numTok=tok.countTokens();
					if (numTok == attribCount){
						System.out.println(line); 
						System.out.println(line2); 
					}
				}
				line = in.readLine();		
			}			
			
			in.close();
		} catch (Exception e){
			e.printStackTrace();
		}	
	}
	
	/**
	 * Remove broken dat lines from a .arff
	 *
	 * @param args
	 */
	public static void main (String args []) {
		if (args.length != 1){
			System.out.println("Remove broken data lines from a .arff file by counting commas");
			System.out.println("FixBrokenArff <arffName>" );
			System.out.println("FixBrokenArff 2d.arff > 2d.fixed.arff" );
		} else {
			String arffName = args[0];
			FixBrokenArff myFixBrokenArff = new FixBrokenArff(arffName);
		}
	}
}