import java.util.*;
/**
 * 
 * @author Sam Danziger
 *
 * 
 */
class GetAllCombos{
	
	static String helpString="Generate all possible combinations fora given list of terms\n"+
					  "USAGE:\n"+
					  "\tGetAllCombos <list>\n"+
					  "\tjava GetAllCombos 1d 2d 3d 4d h1d > comboList.txt";
	
	public static void main (String args []){
		
		/*Parse the command line arguments*/
		if (args.length==0){
			System.out.println(helpString);
			return;
		}
		
		for (int i=0; i<args.length; i++){
			String curArg = args[i];
			
			if (curArg.equalsIgnoreCase("-h")){
				System.out.println(helpString);
				return;
			}
		}
		
		/*Create the lists*/
		ArrayList comboList = new ArrayList();
		for (int i=1; i<=args.length; i++){
			CombinationGenerator x = new CombinationGenerator (args.length, i);
			StringBuffer combination;
			int[] indices;
			while (x.hasMore ()) {
			  combination = new StringBuffer ();
			  indices = x.getNext ();
			  for (int j = 0; j < indices.length; j++) {
			  	if (j == indices.length-1){
					combination.append (args[indices[j]]);
			  	} else {
					combination.append (args[indices[j]]+".");
			  	}
			  }
			  comboList.add(combination.toString());
			  //System.out.println (combination.toString ());
			}
		}
		
		//Sort and print out the results
		Object combos[]=comboList.toArray();
		Arrays.sort(combos);		
		for (int i=0; i<combos.length; i++){
			System.out.println(combos[i]);
		}
	}
}