/*
 * Created on Jan 22, 2005
 *
 * MakeRescueCombos.java:  Combine cancer mutants in one file
 * with rescue combos from another.
 * 
 */

import java.io.BufferedReader;
import java.io.FileReader;
import java.util.ArrayList;
import java.util.StringTokenizer;

class MakeRescueCombos {
    
	/**
	 * Make all rescue combos from a file with cancer, and another with rescue
	 * @param file1
	 * @param file2
	 */
	public MakeRescueCombos(String file1, String file2){
		ArrayList cancerMuts=readList(file1);
		ArrayList rescueMuts=readList(file2);
		
		combineLists(cancerMuts,rescueMuts);
		return;
	}
	
	/**
	 * Pair each cancer mutant with all rescue mutants
	 * @param cancerMuts
	 * @param rescueMuts
	 */
	private void combineLists(ArrayList cancerMuts, ArrayList rescueMuts){
		for (int i=0; i< cancerMuts.size(); i++){
			String curCancer=(String)(cancerMuts.get(i));
			for (int j=0; j<rescueMuts.size(); j++){
				String curRescue=(String)(rescueMuts.get(j));
				System.out.println(curCancer+"_"+curRescue+"\t?");
			}
		}
	}
	
	/**
	 * read in a .def or .list file and store it in an arrayList
	 * @param fileName
	 * @return
	 */
	private ArrayList readList(String fileName){
		ArrayList mutList=new ArrayList();
		try{
	        FileReader inFile = new FileReader(fileName);
	        BufferedReader defReader = new BufferedReader(inFile);
	        
	        String line = defReader.readLine();
	        while(line != null){
	        	StringTokenizer tok = new StringTokenizer(line);
	        	mutList.add(tok.nextToken());
	        	line = defReader.readLine();
	        }
		}catch (Exception e){
			System.err.println(e.getMessage());
		}
		return mutList;
	}
		
  	/**
  	 * Combine all cancer mutants in one file with all possible rescue combos from another
  	 */
	public static void main(String args[]){
		if (args.length != 2) {
			System.out.println("Combine all cancer mutants in one file with all possible rescue combos from another");
			System.out.println("MakeRescueCombos <cancer mutants> <rescue mutants>");
			System.out.println("java MakeRescueCombos cancer.def rescue.def");
		} else {
			MakeRescueCombos myRescueCombos = new MakeRescueCombos(args[0],args[1]);
		}
		
		return;
  	}
}
