import java.io.*;
import java.util.*;

/**
 * 
 * @author Sam Danziger
 *
 * Remove all mutants in list 1 that don't appear in list 2
 */
class RemoveMutsNotUsed{
	ArrayList exclList;
	
	public RemoveMutsNotUsed(String fullName, String exclName){
		//1) Read in all names from exclName
		exclList = readFileList(exclName);
		
		try{
			FileReader inFile = new FileReader(fullName);
			BufferedReader in = new BufferedReader(inFile);
			String line = in.readLine();
		
			PrintWriter out = new PrintWriter(new FileWriter(fullName+".used"));

			while (line != null){
				if (line.startsWith("#")){
					out.println(line);
				} else if (line.length() == 0){
					out.println(line);
				} else 	{
					StringTokenizer tok = new StringTokenizer(line);
					String curTok = tok.nextToken();
					if (exclList.contains(curTok.toLowerCase())){ 
						out.println(line);
					}
				}
				line = in.readLine();
			}		
			
			in.close();
			out.close();
		} catch (Exception e){
			e.printStackTrace();
		}
	}
	
	private ArrayList readFileList(String fileName){
		ArrayList list = new ArrayList();
		try{
			FileReader inFile = new FileReader(fileName);
			BufferedReader in = new BufferedReader(inFile);
			
			String line = in.readLine();
			while(line != null){
				list.add(line.toLowerCase());
				line = in.readLine();
			}
			
			in.close();			
			
		} catch (Exception e){
			e.printStackTrace();
		}
		return list;
	}
	
	/**
	 * Combine the results files to make a new .arff file
	 * RemoveMutsNotUsed <dirListName>, <outName>, <startDir -- optional>
	 * RemoveMutsNotUsed dirList composite.arff
	 *
	 * @param args
	 */
	public static void main (String args []) {
		if ((args.length != 2)){
			System.out.println("Remove all mutnames from <fullList> not in <exclList>" );
			System.out.println("RemoveMutsNotUsed <fullList>, <exclList>" );
			System.out.println("Ex: RemoveMutsNotUsed aircComplete[1].list.txt allUsed.list" );
		} else {
			String fullList = args[0];
			String exclList = args[1];
			RemoveMutsNotUsed myRemoveMutsNotUsed = new RemoveMutsNotUsed(fullList,exclList);
			System.out.println("Completed Execution: Result2Arff "+fullList+" "+exclList);
		}

	}

}