import java.io.BufferedReader;
import java.io.FileReader;
import java.util.Hashtable;
import java.util.StringTokenizer;

/*
 * Created on Mar 2, 2005
 *
 * Renumber a DNA .pdb file and replace the one letter code with 3 letter codes
 */

/**
 * @author sdanzige
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class RenumberDNAPDB {

	private Hashtable DNAlut;
	/**
	 * Contructor 
	 * @param pdbName  The name of the .pdb file to process
	 * @param startIdx  The starting index of the ATOM numbers
	 */
	public RenumberDNAPDB (String pdbName, int atomStart, int resStart){
		initDNAlut();
		int atomIdx=atomStart;
		int resIdx=resStart-1;
		
		try {
			FileReader inFile = new FileReader(pdbName);
			BufferedReader in = new BufferedReader(inFile);
						
			String line = in.readLine();
			int prevResIdx=-1;
			while(line != null){
				StringTokenizer tok = new StringTokenizer(line);
				
				String typeTOK=tok.nextToken();
				String numTOK=tok.nextToken();
				String atomTOK=tok.nextToken();
				String curLetter=tok.nextToken();
				String curChain=tok.nextToken();
				
				if (line.startsWith("TER")){
					//Note, the above labels are messed up for TER
					String newNTname=(String)(DNAlut.get(atomTOK));
					//System.out.println("TER    "+atomIdx+"      "+newNTname+" "+curLetter+"  "+curChain);
					System.out.println("TER    "+atomIdx);
					atomIdx++;
				} else {
					String newNTname=(String)(DNAlut.get(curLetter));
					String halfString[]=line.split(curLetter+" "+curChain+" *[0-9]+");
					if(atomTOK.length()==2){
						atomTOK=atomTOK+" ";
					} else if (atomTOK.length()==1){
						atomTOK=atomTOK+"  ";
					}
					
					//Correct the residue counter
					int oldRes=Integer.parseInt(tok.nextToken());
					if(oldRes != prevResIdx){
						resIdx++;
						prevResIdx=oldRes;
					}
					
					//System.out.println("ATOM   "+startIdx+"  "+atomTOK+" "+newNTname+" "+curChain+halfString[1]);
					System.out.println("ATOM   "+atomIdx+"  "+atomTOK+" "+newNTname+"   "+resIdx+halfString[1]);
					atomIdx++;
				}
				
				line = in.readLine(); 
			}
			
		} catch (Exception e){
			System.out.println(e.getMessage());
			e.printStackTrace();
		}
	}
	
	private void initDNAlut(){
		DNAlut= new Hashtable();
		DNAlut.put("A","ADE");
		DNAlut.put("G","GUA");
		DNAlut.put("C","CYT");
		DNAlut.put("T","THY");
		DNAlut.put("U","URA");
	}
	
	/**
	 *  Renumber a DNA .pdb file and replace the one letter code with 3 letter codes
	 *  RenumberDNAPDB <pdbName> <atomStart> <resStart>
	 *	RenumberDNAPDB DNA.pdb 1200 > DNA_fixed.pdb
	 * @param args
	 */
	public static void main (String args []) {
		if (args.length != 3){
			System.out.println("Renumber a DNA .pdb file and replace the one letter code with 3 letter codes");
			System.out.println("RenumberDNAPDB <pdbName> <atomStart> <resStart>" );
			System.out.println("RenumberDNAPDB DNA.pdb 1200 230 > DNA_fixed.pdb" );
		} else {
			String pdbName = args[0];
			int atomStart = Integer.parseInt(args[1]);
			int resStart = Integer.parseInt(args[2]);
			RenumberDNAPDB myRenumberDNAPBD = new RenumberDNAPDB(pdbName, atomStart, resStart);
			//System.out.println("Completed Execution: RemoveListFromArff "+arffName+" "+listName);
		}
	}
}
