import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.StringTokenizer;

/*
 * Created on Aug 18, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */

/**
 * @author sdanzige
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class callClassifier2result {

	/**
	 * 
	 * @param arffName  The name of the .arff file
	 * @param fileName  The output from callClassifier.java
	 * @param dirName   The directory to store the .result files
	 */
	public callClassifier2result (String arffName, String fileName, String dirName){
		//Read in the mutant names from the .arff file
		ArrayList mutList = readMutsFromArff(arffName);
		
		//Create the results directory
	    boolean success = (new File(dirName)).mkdirs();
	    if (!success) {
	       System.err.println("Directory not created, perhaps it exists.");
	    }
		
		//Process each line of the output file as a new .results file
		try {
			FileReader inFile = new FileReader(fileName);
			BufferedReader in = new BufferedReader(inFile);
			
			String line = in.readLine();
			while(line != null){
				StringTokenizer tok = new StringTokenizer(line);
				String strMutNum=tok.nextToken();
				int mutNum=Integer.parseInt(strMutNum);
				String curMut = (String)(mutList.get(mutNum));
				
				String pred=tok.nextToken();
				String prob=tok.nextToken();
				String truth=tok.nextToken();
				
				writeResult(dirName+"/"+curMut+".result",pred,truth,prob);
				
				line = in.readLine();
			}
			
			
			in.close();
		} catch (Exception e){
			System.out.println(e.getMessage());
			e.printStackTrace();
		}
	}
	
	
	private void writeResult (String fileName, String pred, String truth, String prob){
		try {
			PrintWriter out = new PrintWriter( new FileWriter(fileName));
			out.println("PRED:\t"+pred);
			out.println("TRUTH:\t"+truth);
			out.println("P:\t"+prob);
			out.close();
		} catch (Exception e){
			System.out.println(e.getMessage());
			e.printStackTrace();
		}
	}
	
	/**
	 * Read in the ordered list of mutants from a .arff file with %<mutname> in datalines 
	 * @param arffName
	 * @return
	 */
	private ArrayList readMutsFromArff(String arffName){
		ArrayList mutants=new ArrayList();
		
		try {
			FileReader inFile = new FileReader(arffName);
			BufferedReader in = new BufferedReader(inFile);
			
			String line = in.readLine();
			while(!(line.toLowerCase()).startsWith("@data")){
			    line = in.readLine();
			}
			
			line = in.readLine();
			while(line!= null){
			    if (line.startsWith("%")){
			    	mutants.add(line.substring(1));
			    }
				line = in.readLine();
			}
			
			in.close();
		} catch (Exception e){
			System.out.println(e.getMessage());
			e.printStackTrace();
		}
		
		return mutants;
	}
	
	/**
	 * Convert the results of an xvalidation made from callClassifier.java to a 
     * directory of .result files
	 * callClassifier2result <arffFile> <outFile> <outDir - DEFAULT:results>
	 * callClassifier2result in.arff callClassifier.out results
	 *
	 * @param args
	 */
	public static void main (String args []) {
		if (args.length != 2 && args.length != 3){
			System.out.println("Convert the results of an xvalidation made from callClassifier.java to a directory of .result files");
			System.out.println("callClassifier2result <arffFile> <outFile> <outDir - DEFAULT:results>" );
			System.out.println("callClassifier2result in.arff callClassifier.out results" );
		} else {
			String arffName = args[0];
			String fileName = args[1];
			if (args.length==2){
				callClassifier2result myRemoveListFromArff = new callClassifier2result(arffName, fileName, "results");
			} else {
				callClassifier2result myRemoveListFromArff = new callClassifier2result(arffName, fileName, args[2]);
			}
		}
	}
}
