
import java.util.*;
import java.io.*;
import weka.core.*;
import weka.classifiers.*;
import weka.estimators.*;
import java.util.zip.GZIPInputStream;
import java.util.zip.GZIPOutputStream;


public class CWeka {

	static Classifier classifier;

	public static void main(String [] args) {
	}

	public static void loadModel(String objectInputFileName) { 
          try {
                InputStream is = new FileInputStream(objectInputFileName);
                if (objectInputFileName.trim().endsWith(".gz"))
                  is = new GZIPInputStream(is);
                ObjectInputStream ois = new ObjectInputStream(is);
                classifier = (Classifier) ois.readObject();
                ois.close();
          } catch (Exception e) {
                e.printStackTrace(System.err);
          }
	}

        public static void loadModel(Classifier classifier, String objectInputFileName) {
          try {
                InputStream is = new FileInputStream(objectInputFileName);
                if (objectInputFileName.trim().endsWith(".gz"))
                  is = new GZIPInputStream(is);
                ObjectInputStream ois = new ObjectInputStream(is);
                classifier = (Classifier) ois.readObject();
                ois.close();
          } catch (Exception e) {
                e.printStackTrace(System.err);
          }
        }

	public static void loadClassifier (String classifierString) {
	  try {
      		classifier=(Classifier)Class.forName(classifierString).newInstance();
    	  } catch (Exception e) {
		e.printStackTrace(System.err);
	  };
	}

	public static Classifier loadModel(char classifier[],char model[]) {
	  Classifier c;
          try {
                c=(Classifier)Class.forName(new String(classifier).trim()).newInstance();
		loadModel(c, new String(model).trim());
		return c;
          } catch (Exception e) {
		e.printStackTrace(System.err);
		return null;
          }
	}

	public static double classify(double[] data) throws Exception {
	        return classifier.classifyInstance(new Instance(1,data));
	}	

        public static double classify(Classifier classifier, double[] data) {
                try{
		  Instance i = new Instance(1,data);
		System.err.println(i);
			return classifier.classifyInstance(i); 
 		}
		catch(Exception e) {
	          e.printStackTrace(System.err);
                  return 0;
          	}
        }

	public static void initModel(char[] classifierName, char[] modelFile) throws Exception{
		classifier = (Classifier)Class.forName(new String(classifierName).trim()).newInstance();
		loadModel(new String(modelFile));	
	}
}
